<?php
namespace Teknisa\CTB\Modules\Saldos\Controllers;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request\Row;
use Teknisa\CTB\Modules\Saldos\Services\Ctb22100RazaoGerencialService;

class Ctb22100RazaoGerencialController {

    protected $entityManager;
    protected $service;

    public function __construct(EntityManager $entityManager, Ctb22100RazaoGerencialService $service) {
        $this->entityManager = $entityManager;
        $this->service       = $service;
    }
        
    public function geraRazaoGerencial(Row $row, Response $response)
    {
        ini_set('memory_limit', '1024M');
        ini_set('max_execution_time', '7200');
        set_time_limit(7200);
        try {
            $row = $row->getRow();
            
            $nrctbtemp = $this->service->geraRazaoGerencial($row, $response);
            
            $response->addDataSet(new DataSet('ctbtemp', [$nrctbtemp]));
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
}
