CREATE OR REPLACE PROCEDURE LANCTOEST_COMISSARIA(
P_IDMOVEST     IN VARCHAR2, /*1 - Emisso do Delivery, 2 - Fechamento do delivery, 3 - Cancelamento do Fechamento do Delviery*/
P_CDFILIAL     IN FILIAL     .CDFILIAL  %TYPE,
P_NRDELIVERY   IN DELIVERY   .NRDELIVERY%TYPE,
P_CDOPERADOR   IN OPERADOR   .CDOPERADOR%TYPE,
P_NRLANCESTQS OUT LANCTOESTOQ.NRLANCESTQ%TYPE,
P_NRLANCESTQE OUT LANCTOESTOQ.NRLANCESTQ%TYPE
) AS
V_NRLANCESTQS  VARCHAR2(20);
V_NRLANCESTQE  VARCHAR2(20);
V_NRSEQUITEM   ITLANCTOEST.NRSEQUITEM%TYPE;
V_NRSEQUITEM2  ITLANCTOEST.NRSEQUITEM%TYPE;
V_QTDEINSERIDA NUMBER;
V_QTDE         NUMBER;
V_CDALMOXPISTA PARAMCOMIS.CDALMOXPISTA%TYPE;
V_CDLOCESTPIST PARAMCOMIS.CDLOCESTPIST%TYPE;
V_CDALMOXHOLD  PRODFILI  .CDALMOXPRACA%TYPE;
V_CDLOCESTHOLD PRODFILI  .CDLOCALPRACA%TYPE;

V_NRMAXORDPROD VARCHAR2(60);
V_QTPRACABADO  PRODACABADO.QTPRACABADO %TYPE;
V_VRPRACABADO  PRODACABADO.VRPRACABADO %TYPE;
V_VRLANCTOBRUT ITLANCTOEST.VRLANCTOBRUT%TYPE;
V_VRUNILANCTO  ITLANCTOEST.VRUNILANCTO %TYPE;
V_VRLANCTOEST  ITLANCTOEST.VRLANCTOEST %TYPE;
V_VRCUSTENTR   ITLANCTOEST.VRCUSTENTR  %TYPE;
V_VRTOTLANCTO  ITLANCTOEST.VRTOTLANCTO %TYPE;

BEGIN
/*
IDLOCALEST
'1' - Produo
'2' - Holding Box
'3' - Pista
'4' - Embarque
'5' - Perda
*/
/************************************************************************************/
/* Produo                  - (NO H CONTROLE DE ESTOQUE)                         */
/* Produo    / Perda       - (NO H CONTROLE DE ESTOQUE)                         */
/* Produo    / Holding Box - (A ATUALIZAO DO ESTOQUE SER FEITA EM OUTRO LOCAL) */
/* Holding Box / Perda       - (MANUAL)                                             */
/* Holding Box / Pista       - (EMISSO DE DELIVERY)                                */
/* Pista       / Embarque    - (FECHAMENTO DO DELIVERY)                             */
/* Pista       / Holding Box - (MANUAL)                                             */
/* Pista       / Perda       - (MANUAL)                                             */
/* Embarque    / Pista       - (CANCELAMENTO DO FECHAMENTO DO DELIVERY)             */
/************************************************************************************/
/*=============================MOVIMENTAO DE ESTOQUE========================*/
   SELECT MAX(CDALMOXPISTA), MAX(CDLOCESTPIST)
   INTO V_CDALMOXPISTA, V_CDLOCESTPIST
   FROM PARAMCOMIS
   WHERE (CDFILIAL = P_CDFILIAL);
   IF (V_CDALMOXPISTA IS NULL) OR (V_CDLOCESTPIST IS NULL) THEN
		raise_application_error(-20501, 'Alm_Loc_Pr' , True);
      /*'No h almoxarifado e localizao de pista parametrizado.' , True);*/
   END IF;
   IF P_IDMOVEST <> '3' THEN /* DIFERENTE DE CANCELAMENTO DO FECHAMENTO DO DELIVERY */
      NOVO_CODIGO_SC('LANCTOEST'||P_CDFILIAL, V_NRLANCESTQS, 1);
      INSERT INTO LANCTOESTOQ
      (CDFILIAL,NRLANCESTQ,NRLANCTONF,IDTPLANCTO,DTLANCESTQ,DSLANCESTQ,IDALTCUSMED,
       CDOPERADOR,IDENTRSAIDOP,CDTIPOOPER,NRPROCPROD,CDFILIMOVI,CDALMOXARIFE,
       CDLOCALESTOQ,NRTROCA)
      VALUES
      (P_CDFILIAL,SUBSTR(V_NRLANCESTQS,11,10),'','4',TRUNC(SYSDATE),P_NRDELIVERY,'N',
       P_CDOPERADOR,'S','','','','',
       '','');
   END IF;
   IF P_IDMOVEST <> '2' THEN /* DIFERENTE DE FECHAMENTO DO DELIVERY */
      NOVO_CODIGO_SC('LANCTOEST'||P_CDFILIAL, V_NRLANCESTQE, 1);
      INSERT INTO LANCTOESTOQ
      (CDFILIAL,NRLANCESTQ,NRLANCTONF,IDTPLANCTO,DTLANCESTQ,DSLANCESTQ,IDALTCUSMED,
       CDOPERADOR,IDENTRSAIDOP,CDTIPOOPER,NRPROCPROD,CDFILIMOVI,CDALMOXARIFE,
       CDLOCALESTOQ,NRTROCA)
      VALUES
      (P_CDFILIAL,SUBSTR(V_NRLANCESTQE,11,10),'','2',TRUNC(SYSDATE),P_NRDELIVERY,'N',
       P_CDOPERADOR,'E','','','','',
       '','');
   END IF;
   V_NRSEQUITEM  := 0;
   V_NRSEQUITEM2 := 0;
   FOR C_SERV IN (SELECT SP.CDSERVICO,SUM(SP.QTSERFATSP) AS QTDESERV/*,
                         PA.QTPRACABADO,PA.VRPRACABADO*/
                  FROM SERVPLANO SP/*, PRODACABADO PA*/
                  WHERE (SP.CDFILIAL   = P_CDFILIAL  ) AND
                        (SP.NRDELIVERY = P_NRDELIVERY) /*AND
                        (PA.CDFILIAL   = SP.CDFILIAL ) AND
                        (PA.CDPRODUTO  = SP.CDSERVICO) AND
                        ((PA.NRORDPROD||PA.NRSUBORDPROD||PA.CDSUBPRODETA||PA.NRSUBPRETAOP||PA.NRPRODACAB) =
                         (SELECT MAX(NRORDPROD||NRSUBORDPROD||CDSUBPRODETA||NRSUBPRETAOP||NRPRODACAB)
                          FROM PRODACABADO
                          WHERE (CDFILIAL  = PA.CDFILIAL ) AND
                                (CDPRODUTO = PA.CDPRODUTO)))*//*AND
                        (SP.IDSITSERSP = '2'         )*/
                  GROUP BY SP.CDSERVICO/*,PA.QTPRACABADO,PA.VRPRACABADO*/)LOOP

      SELECT MAX(NRORDPROD||NRSUBORDPROD||CDSUBPRODETA||NRSUBPRETAOP||NRPRODACAB) NRMAXORDPROD
      INTO V_NRMAXORDPROD
      FROM PRODACABADO
      WHERE (CDFILIAL  = P_CDFILIAL      ) AND
            (CDPRODUTO = C_SERV.CDSERVICO);

      SELECT MAX(QTPRACABADO),MAX(VRPRACABADO)
      INTO V_QTPRACABADO,V_VRPRACABADO
      FROM PRODACABADO
      WHERE (CDFILIAL   = P_CDFILIAL      ) AND
            (CDPRODUTO  = C_SERV.CDSERVICO) AND
            ((NRORDPROD||NRSUBORDPROD||CDSUBPRODETA||NRSUBPRETAOP||NRPRODACAB) = V_NRMAXORDPROD);

      V_VRLANCTOBRUT := V_VRPRACABADO;
      V_VRUNILANCTO  := V_VRPRACABADO;
      V_VRLANCTOEST  := V_VRPRACABADO;
      V_VRCUSTENTR   := (V_QTPRACABADO*V_VRPRACABADO);
      V_VRTOTLANCTO  := (V_QTPRACABADO*V_VRPRACABADO);

      V_NRSEQUITEM := (V_NRSEQUITEM + 1);
      IF P_IDMOVEST = '2' THEN /* FECHAMENTO DO DELIVERY - (Pista / Embarque)*/
         INSERT INTO ITLANCTOEST
         (CDFILIAL,NRLANCESTQ,NRSEQUITEM,CDPRODUTO,
          QTLANCTOEST,QTTOTLANCTO,CDPRODMOVI,CDFILIMOVI,
          CDALMOXARIFE,CDLOCALESTOQ,NRLOTEESTQ,NRSUBLOTE,
          IDTIPOMOVI,
          VRLANCTOBRUT,VRUNILANCTO,VRLANCTOEST,VRCUSTENTR,VRTOTLANCTO)
         VALUES
         (P_CDFILIAL,SUBSTR(V_NRLANCESTQS,11,10),V_NRSEQUITEM,C_SERV.CDSERVICO,
          C_SERV.QTDESERV,C_SERV.QTDESERV,C_SERV.CDSERVICO,P_CDFILIAL,
          V_CDALMOXPISTA,V_CDLOCESTPIST,' ',' ',
          '4',
          V_VRLANCTOBRUT,V_VRUNILANCTO,V_VRLANCTOEST,V_VRCUSTENTR,V_VRTOTLANCTO);
         ATUALIZA_ESTOQUE(P_CDFILIAL, TRUNC(SYSDATE), TRUNC(SYSDATE), P_CDFILIAL, SUBSTR(V_NRLANCESTQS,11,10));
      ELSE
         IF P_IDMOVEST = '1' THEN /* EMISSO DE DELIVERY - (Holding Box / Pista) */
            V_QTDEINSERIDA := 0;
            /*FOR C_PRAC IN (SELECT CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO,
                                  SUM(QTPRACABADO) AS QTDEACAB
                           FROM PRODACABADO
                           WHERE (CDFILIAL     = P_CDFILIAL         ) AND
                                 (NRORDPROD    = C_SERV.NRORDPROD   ) AND
                                 (NRSUBORDPROD = C_SERV.NRSUBORDPROD) AND
                                 (CDPRODUTO    = C_SERV.CDSERVICO   )
                           GROUP BY
                              CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO)LOOP*/

            /* 17/06/2004 - Leonardo Monteiro
               Foi substitudo para dar baixa no servio do holding do local de
               estoque e almoxarifado fixo parametrizado no mdulo de estoque.
               No testar mais a existncia de servio na Pista. Isso ser feito
               no programa de Emisso de Delivery.

               FOR C_HOLD IN (SELECT CDALMOXARIFE,CDLOCALESTOQ,NRLOTEESTQ,NRSUBLOTE,CDSERVICO,
                                  SUM(QTSERVEST) AS QTDEACAB
                           FROM EST_LOCALHOLDING
                           WHERE (CDFILIAL     = P_CDFILIAL         ) AND
                                 (CDSERVICO    = C_SERV.CDSERVICO   )
                           GROUP BY CDALMOXARIFE,CDLOCALESTOQ,NRLOTEESTQ,
                                    NRSUBLOTE,CDSERVICO)LOOP
               EXIT WHEN (V_QTDEINSERIDA < C_SERV.QTDESERV);
               IF V_QTDEINSERIDA < C_SERV.QTDESERV THEN
                  IF (C_SERV.QTDESERV - V_QTDEINSERIDA) >= C_HOLD.QTDEACAB THEN
                     V_QTDE := C_HOLD.QTDEACAB;
                  ELSE
                     V_QTDE := C_SERV.QTDESERV - V_QTDEINSERIDA;
                  END IF;
                  V_QTDEINSERIDA := V_QTDEINSERIDA + V_QTDE;
*===LANAMENTO DE SADA===*
                  V_NRSEQUITEM2 := (V_NRSEQUITEM2 + 1);
                  INSERT INTO ITLANCTOEST
                  (CDFILIAL,NRLANCESTQ,NRSEQUITEM,CDPRODUTO,QTLANCTOEST,QTTOTLANCTO,
                   CDPRODMOVI,CDFILIMOVI,CDALMOXARIFE,CDLOCALESTOQ,
                   NRLOTEESTQ,NRSUBLOTE,IDTIPOMOVI,
                   VRLANCTOBRUT,VRUNILANCTO,VRLANCTOEST,VRCUSTENTR,VRTOTLANCTO)
                  VALUES
                  (P_CDFILIAL,SUBSTR(V_NRLANCESTQS,11,10),V_NRSEQUITEM2,C_HOLD.CDSERVICO,V_QTDE,V_QTDE,
                   C_HOLD.CDSERVICO,P_CDFILIAL,C_HOLD.CDALMOXARIFE,C_HOLD.CDLOCALESTOQ,
                   C_HOLD.NRLOTEESTQ,C_HOLD.NRSUBLOTE,'4',
                   V_VRLANCTOBRUT,V_VRUNILANCTO,V_VRLANCTOEST,V_VRCUSTENTR,V_VRTOTLANCTO);
                  ATUALIZA_ESTOQUE(P_CDFILIAL, TRUNC(SYSDATE), TRUNC(SYSDATE), P_CDFILIAL, SUBSTR(V_NRLANCESTQS,11,10));
*=========================*
               END IF;
            END LOOP;*/

            SELECT MAX(CDALMOXPRACA),MAX(CDLOCALPRACA)
            INTO V_CDALMOXHOLD,V_CDLOCESTHOLD
            FROM PRODFILI
            WHERE (CDFILIAL  = P_CDFILIAL      ) AND
                  (CDPRODUTO = C_SERV.CDSERVICO);

            IF (V_CDALMOXHOLD IS NULL) OR (V_CDLOCESTHOLD IS NULL) THEN
               raise_application_error(-20501, 'Eser_Holbx'||'                    '||C_SERV.CDSERVICO||'*', True);
               /*'No h almoxarifado e localizao de holding box parametrizado para o servio "'||C_SERV.CDSERVICO||'".' , True);*/
            END IF;

            V_QTDE := C_SERV.QTDESERV;
/*===LANAMENTO DE SADA===*/
               V_NRSEQUITEM2 := (V_NRSEQUITEM2 + 1);
               INSERT INTO ITLANCTOEST
               (CDFILIAL,NRLANCESTQ,NRSEQUITEM,CDPRODUTO,QTLANCTOEST,QTTOTLANCTO,
                CDPRODMOVI,CDFILIMOVI,CDALMOXARIFE,CDLOCALESTOQ,
                NRLOTEESTQ,NRSUBLOTE,IDTIPOMOVI,
                VRLANCTOBRUT,VRUNILANCTO,VRLANCTOEST,VRCUSTENTR,VRTOTLANCTO)
               VALUES
               (P_CDFILIAL,SUBSTR(V_NRLANCESTQS,11,10),V_NRSEQUITEM2,C_SERV.CDSERVICO,V_QTDE,V_QTDE,
                C_SERV.CDSERVICO,P_CDFILIAL,V_CDALMOXHOLD,V_CDLOCESTHOLD,
                ' ',' ','4',
                V_VRLANCTOBRUT,V_VRUNILANCTO,V_VRLANCTOEST,V_VRCUSTENTR,V_VRTOTLANCTO);
               ATUALIZA_ESTOQUE(P_CDFILIAL, TRUNC(SYSDATE), TRUNC(SYSDATE), P_CDFILIAL, SUBSTR(V_NRLANCESTQS,11,10));
/*=========================*/
         END IF;
/*==LANAMENTO DE ENTRADA==*/
         /*UPDATE SERVBREAK
         SET QTSERVHOLD = QTSERVHOLD - C_HOLD.QTDEACAB,
             QTSERVPIST = QTSERVPIST + C_HOLD.QTDEACAB,
             IDLOCALEST = '3',
             DSMOVEST   = 'Emisso do Delivery '||TO_CHAR(P_NRDELIVERY),
             CDOPERADOR = P_CDOPERADOR
         WHERE (CDFILIAL    = P_CDFILIAL        ) AND
               (NRBREAKDOWN = C_SERV.NRBREAKDOWN) AND
               (CDCIA       = C_SERV.CDCIA      ) AND
               (CDSERVICO   = C_SERV.CDSERVICO  ) AND
               (CDCLASSE    = C_SERV.CDCLASSE   ) AND
               (CDCICLO     = C_SERV.CDCICLO    );*/
         INSERT INTO ITLANCTOEST
         (CDFILIAL,NRLANCESTQ,NRSEQUITEM,CDPRODUTO,QTLANCTOEST,
          QTTOTLANCTO,CDPRODMOVI,CDFILIMOVI,CDALMOXARIFE,CDLOCALESTOQ,
          NRLOTEESTQ,NRSUBLOTE,IDTIPOMOVI,
          VRLANCTOBRUT,VRUNILANCTO,VRLANCTOEST,VRCUSTENTR,VRTOTLANCTO)
         VALUES
         (P_CDFILIAL,SUBSTR(V_NRLANCESTQE,11,10),V_NRSEQUITEM,C_SERV.CDSERVICO,C_SERV.QTDESERV,
          C_SERV.QTDESERV,C_SERV.CDSERVICO,P_CDFILIAL,V_CDALMOXPISTA,V_CDLOCESTPIST,
          ' ',' ','2',
          V_VRLANCTOBRUT,V_VRUNILANCTO,V_VRLANCTOEST,V_VRCUSTENTR,V_VRTOTLANCTO);
         ATUALIZA_ESTOQUE(P_CDFILIAL,TRUNC(SYSDATE),TRUNC(SYSDATE),P_CDFILIAL,SUBSTR(V_NRLANCESTQE,11,10));
/*=========================*/
		END IF;
   END LOOP;
   P_NRLANCESTQS := V_NRLANCESTQS;
   P_NRLANCESTQE := V_NRLANCESTQE;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LANCTOEST_COMISSARIA','4.11.022'); END;
/

