/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOCARD                                                 */
/* Tabela : TIPOCARD                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 01/02/2005 - Henrique Dias Borges                                          */
/*                                                                            */
/******************************************************************************/
IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPOCARD' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPOCARD
GO

CREATE TRIGGER DTULTATU_TIPOCARD
ON TIPOCARD
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOCARD', NULL, 'CDFILCENTPME='+ CDFILCENTPME+';'+'CDTIPOCARD='+CDTIPOCARD+';',GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPOCARD
      SET DTULTATUTCAR = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPOCARD.CDFILCENTPME,0) = ISNULL(INSERTED.CDFILCENTPME,0)) AND
            (ISNULL(TIPOCARD.CDTIPOCARD,0) = ISNULL(INSERTED.CDTIPOCARD,0))   ;
   END;
END;
GO
